// Beycan KAHRAMAN - 040020337 - 28.04.2007
// diff - ADVANCED PROGRAMMING - Java 

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class differ {
	
	boolean []parameters;
	ArrayList<String> file1, file2;
	ArrayList<String> fileOrg1, fileOrg2;
	int []errorStart1;
	int []errorStart2;
	int []errorEnd1;
	int []errorEnd2;
	char []errorType;
	int errorNo;
	
	public differ(){ // constructor
		parameters = new boolean[4];
		for(int i=0; i<4; i++)
			parameters[i] = false;
		
		file1 = new ArrayList<String>();
		file2 = new ArrayList<String>();
		fileOrg1 = new ArrayList<String>();
		fileOrg2 = new ArrayList<String>();
		
		errorNo = 0;
	}
	
	public boolean setParameters(String[] args){ // get parameters
		for(int i=2; i<args.length; i++){
			if(args[i].compareTo("-i") == 0)
				parameters[0] = true;
			else if(args[i].compareTo("-w") == 0)
				parameters[1] = true;
			else if(args[i].compareTo("-u") == 0)
				parameters[2] = true;
			else if(args[i].compareTo("-c") == 0)
				parameters[3] = true;
		}
		if(parameters[2] == true && parameters[3] == true)
			return true;
		return false;
	}
	
	// read given file 
	private void readFile(String file_str, ArrayList<String> file_arr, ArrayList<String> file_org_arr) throws IOException{
		FileReader f = new FileReader(file_str);
        BufferedReader reader = new BufferedReader(f);
        while (true) {
            String line = reader.readLine();
            if (line == null)
                break;
            file_org_arr.add(line);
            if(parameters[0]){
            	line = line.toLowerCase();
            }
            if(parameters[1]){
            	StringTokenizer st = new StringTokenizer(line);
            	line = "";
                while(st.hasMoreTokens()) 
                	line += " " + st.nextToken();
            }
            file_arr.add(line);
        }
        f.close();
	}
	
	public void readFiles(String file_1, String file_2) throws IOException{
		readFile(file_1, file1, fileOrg1);
		readFile(file_2, file2, fileOrg2);
	}
	
	// do diff job
	public void diff(){
		int f1 = 0, f2 = 0;
		int f1size = file1.size(), f2size = file2.size();
		
		errorStart1 = new int[f1size];
		errorStart2 = new int[f2size];
		errorEnd1 = new int[f1size];
		errorEnd2 = new int[f2size];
		errorType = new char[f1size];
		
		while(f1 < f1size && f2 < f2size){
			if(file1.get(f1).compareTo(file2.get(f2)) != 0){
					errorStart1[errorNo] = f1;
					errorStart2[errorNo] = f2;
					if (f1 == f1size-1){
						f1++;
						break;
					}
					if (f2 == f2size -1){
						f2++;
						break;
					}
					for(int i=f1; i<f1size; ++i)
						for(int j=f2; j<f2size; ++j)
							if(file1.get(i).compareTo(file2.get(j)) == 0){
								errorEnd1[errorNo] = i;
								errorEnd2[errorNo] = j;
								i = f1size;
								j = f2size;
								
								if(errorEnd1[errorNo] - errorStart1[errorNo] == 0)
									errorType[errorNo] = 'a';
								else if(errorEnd2[errorNo] - errorStart2[errorNo] == 0){
									errorType[errorNo] = 'd';
								}else
									errorType[errorNo] = 'c';
								i = f1size;
								break;
							}else{
								errorEnd1[errorNo] = i;
								errorEnd2[errorNo] = j;
							}
					f1 = errorEnd1[errorNo];
					f2 = errorEnd2[errorNo];
					++errorNo;
			}else{
				++f1;
				++f2;
			}
		}
		
		if(f1 < f1size){
			errorStart1[errorNo] = f1;
			errorStart2[errorNo] = f2;
			errorEnd1[errorNo] = f1size;
			errorEnd2[errorNo] = f2size;
			errorType[errorNo++] = 'd';
		}else if(f2 < f2size){
			errorStart1[errorNo] = f1;
			errorStart2[errorNo] = f2;
			errorEnd1[errorNo] = f1size;
			errorEnd2[errorNo] = f2size;
			errorType[errorNo++] = 'a';
		}
	}
	
	// print diff 
	public void printDiff(){
		if(parameters[2]){ // -u
			int ourError = 0;
			int k = 0;
			for(int i=0; i<fileOrg1.size(); ++i){
				if(i < errorStart1[ourError])
					System.out.println(i + "  \t" + fileOrg1.get(i));
				else if(ourError > errorNo-1)
					System.out.println(i + "  \t" + fileOrg1.get(i));
				else{
					for(int j=i; j<errorEnd1[ourError] && j<fileOrg1.size(); ++j){
						if(errorType[ourError] == 'd')
							System.out.println(i + " -\t" + fileOrg1.get(i++));
						else if(errorType[ourError] == 'c')
							System.out.println(i + " -\t" + fileOrg1.get(i++));
					}
					for(int j=errorStart2[ourError]; j<errorEnd2[ourError] && j<fileOrg2.size(); ++j){
						if(errorType[ourError] == 'a')
							System.out.println(j + " +\t" + fileOrg2.get(j));
						else if(errorType[ourError] == 'c')
							System.out.println(j + " +\t" + fileOrg2.get(j));
					}
					--i;
					++ourError;
				}
			}
		}else if(parameters[3]){ // -c
			int ourError = 0;
			for(int i=0; i<fileOrg1.size(); ++i){
				if(i < errorStart1[ourError])
					System.out.println(i + "  \t" + fileOrg1.get(i));
				else if(ourError > errorNo-1)
					System.out.println(i + "  \t" + fileOrg1.get(i));
				else{
					for(int j=i; j<errorEnd1[ourError] && j<fileOrg1.size(); ++j){
						if(errorType[ourError] == 'd')
							System.out.println(i + " -\t" + fileOrg1.get(i++));
						else if(errorType[ourError] == 'c')
							System.out.println(i + " !\t" + fileOrg1.get(i++));
					}
					--i;
					++ourError;
				}
			}
			System.out.println("-----------------------------------------------------------");
			ourError = 0;
			for(int i=0; i<fileOrg2.size(); ++i){
				if(i < errorStart2[ourError])
					System.out.println(i + "  \t" + fileOrg2.get(i));
				else if(ourError > errorNo-1)
					System.out.println(i + "  \t" + fileOrg2.get(i));
				else{
					for(int j=i; j<errorEnd2[ourError] && j<fileOrg2.size(); ++j){
						if(errorType[ourError] == 'a')
							System.out.println(i + " +\t" + fileOrg2.get(i++));
						else if(errorType[ourError] == 'c')
							System.out.println(i + " !\t" + fileOrg2.get(i++));
					}
					--i;
					++ourError;
				}
			}
		}else{ // normal
			for(int i=0; i<errorNo; ++i){
				System.out.print("\t" + errorStart1[i] + "");
				if(errorEnd1[i] > 0 && errorEnd1[i] < fileOrg1.size())
					System.out.print(","+errorEnd1[i]);
				System.out.print(" "+errorType[i] + " ");
				System.out.print(errorStart2[i] + "");
				if(errorEnd2[i] > 0 && errorEnd2[i] < fileOrg2.size())
					System.out.print(","+errorEnd2[i]);
				System.out.println("");
				if(errorType[i] == 'd' || errorType[i] == 'c'){
					if(errorStart1[i] > 0)
						System.out.println((errorStart1[i]-1) + "  \t" + fileOrg1.get(errorStart1[i] - 1));
					for(int j=errorStart1[i]; j<errorEnd1[i]; ++j)
						System.out.println(j + " <\t" + fileOrg1.get(j));
					if(errorEnd1[i] < fileOrg1.size())
						System.out.println(errorEnd1[i] + "  \t" + fileOrg1.get(errorEnd1[i]));
				}
				System.out.println("-----------------------------------------------------------");
				if(errorType[i] == 'a' || errorType[i] == 'c'){
					if(errorStart2[i] > 0)
						System.out.println((errorStart2[i]-1) + "  \t" + fileOrg2.get(errorStart2[i] - 1));
					for(int j=errorStart2[i]; j<errorEnd2[i]; ++j)
						System.out.println(j + " >\t" + fileOrg2.get(j));
					if(errorEnd2[i] < fileOrg2.size())
						System.out.println(errorEnd2[i] + "  \t" + fileOrg2.get(errorEnd2[i]));
				}
				System.out.println("");
			}
		}
	}
	
	// MAIN FUNCTION
	public static void main(String[] args) {
		if(args.length < 2){
			System.out.println("USAGE: program file1 file2 [parameters]");
			System.exit(-1);
		}
		differ diff = new differ();
		
		if(args.length > 2){
			boolean confuse = diff.setParameters(args);
			if(confuse){
				System.out.println("PARAMETER ERROR: confusing parameters ( -c & -u )");
				System.exit(-1);
			}
		}
		
		try {
			diff.readFiles(args[0], args[1]);
		} catch (IOException e) {
			System.out.println("FILE ERROR: files could not be found or read");
			System.exit(-1);
		}
		
		diff.diff(); // do job
		
		diff.printDiff(); // print result
	}

}
